

#Compile Exe
#Register None
#Dim All
'
' In this program only listview and header controls use the COMMCTRL.INC file
%NOANIMATE       = 1  ' Animate control.
%NOBUTTON        = 1
%NOCOMBO         = 1
%NODATETIMEPICK  = 1
%NODRAGLIST      = 1  ' APIs to make a listbox source and sink drag&drop actions.
%NOEDIT          = 1
%NOFLATSBAPIS    = 1
'    %NOHEADER        = 1  ' Header bar control.
%NOHOTKEY        = 1  ' HotKey control.
%NOIMAGELIST     = 1  ' ImageList apis.
%NOIPADDRESS     = 1
%NOLIST          = 1
'    %NOLISTVIEW      = 1  ' ListView control.
%NOMENUHELP      = 1  ' APIs to help manage menus, especially with a status bar.
%NOMONTHCAL      = 1
%NOMUI           = 1
%NONATIVEFONTCTL = 1
%NOPAGESCROLLER  = 1
%NOPROGRESS      = 1  ' Progress gas gauge.
%NOREBAR         = 1
%NOSTATUSBAR     = 1  ' Status bar control.
%NOTABCONTROL    = 1
%NOTOOLBAR       = 1  ' Customizable bitmap-button toolbar control.
%NOTOOLTIPS      = 1
%NOTRACKBAR      = 1  ' Customizable column-width tracking control.
%NOTREEVIEW      = 1  ' TreeView control.
%NOUPDOWN        = 1  ' Up and Down arrow increment/decrement control.
'
#Include "WIN32API.INC"
#Include "COMMCTRL.INC"
'
%ListViewGrid       = 100
%ExitButton         = 115
%VertScrollbar      = 135
%HorzScrollbar      = 140
%EditDescript       = 145
'
%EditLabel          = 400
%EditText           = 410
%EditOK             = 415
%EditCancel         = 420
'
%LabelRadioButtonAction    = 600
%RadioButtonFinishEditing  = 605
%RadioButtonEditRight      = 610
%RadioButtonEditBelow      = 615
' --------------------------------------------------
Declare Sub ShowListDialog(ByVal hParent&)
Declare CallBack Function CBF_Exit()
Declare CallBack Function ListFrameCallBack()
Declare CallBack Function ListViewWindowCallBack()
Declare Sub UpdateColumnsAndHorzScrollbar (ByVal xPos As Long)
'
Declare CallBack Function EditDialogProc
Declare CallBack Function CBF_EditText()
Declare CallBack Function CBF_EditOK()
Declare CallBack Function CBF_EditCancel()
'
Declare CallBack Function CBF_RadioButtonFinishEdit()
Declare CallBack Function CBF_RadioButtonEditRight()
Declare CallBack Function CBF_RadioButtonEditBelow()
'
Declare Function MakeFont(ByVal FontTypeSize As Long,ByVal FontWeight As Long, _
    ByVal Italic As Long, ByVal Underline As Long,ByVal StrikeOut As Long, _
    ByVal FaceName As String) As Long
' --------------------------------------------------
Global hListForm&           ' Dialog handle
Global hListFrame&          ' Dialog handle
Global hListWindow&         ' Dialog handle
Global hHeader&             ' Column header handle (within listview)
Global hEditForm&           ' Dialog handle
Global Rows As Long         ' Total number of rows in array
Global Columns As Long      ' Total number of columns in array
Global PageRows As Long     ' Number of rows on a page
Global PageColumns As Long  ' Number of columns on a page
Global DataArray() As String' Two dimensional text array to be displayed
Global ColWidth() As Long   ' Column width array
Global siX As SCROLLINFO
Global gOldSubClassProc&
Global gOldSubClassEdit&
Global SelX As Long         ' Column selected
Global SelY As Long         ' Row selected
Global XCR!,YCR!            ' conversion factors from pixels to dialog units
Global XMaxScr As Long
Global YMaxScr As Long
'
Global RainBowColors() As Long
Global TextColor() As Long
Global TextFont() As Long
Global EditFlag&
' --------------------------------------------------
'
Function XDU(XPct As Single) As Long  ' X transformation function just for this program
    XDU=XPct*800*0.01/XCR!
End Function
'
Function YDU(YPct As Single) As Long  ' Y transformation function just for this program
    YDU=YPct*543*0.01/YCR!
End Function
'
' --------------------------------------------------
Function PBMain
    Local hDC As Long
    Local Style&, ExStyle&
    Local X&,Y&,X1&,Y1&,hDlg&
    Local CC1 As INIT_COMMON_CONTROLSEX
    CC1.dwSize=SizeOf(CC1)
    CC1.dwICC=%ICC_WIN95_CLASSES
    InitCommonControlsEX CC1
    XMaxScr=GetSystemMetrics(%SM_CXFULLSCREEN)
    If XMaxScr >800 Then XMaxScr=800
    YMaxScr=GetSystemMetrics(%SM_CYFULLSCREEN)
    If YMaxScr >543 Then YMaxScr=543
    X&=300: Y&=200
    Dialog New 0,"",,,X&,Y&, %WS_VISIBLE, To hDlg&
    Dialog Units hDlg&, X&, Y& To Pixels X1&, Y1&
    Dialog End hDlg&
    XCR!=X1&*10000/X&: XCR!=XCR!/10000
    YCR!=Y1&*10000/Y&: YCR!=YCR!/10000
    ' Accomodation of small and big Fonts windows settings
    ' May be improved
    If XCR!<1.75 Then YCR!=1.87 Else YCR!=1.90
    '
    Style& = %WS_POPUP Or %DS_MODALFRAME Or %WS_CAPTION Or %WS_MINIMIZEBOX Or %WS_SYSMENU Or %DS_CENTER
    ExStyle& = 0
    ' Create frame window with horizontal scroll bar etc.
    Dialog New 0, "Virtual ListView With Integrated Row Header - Fonts, Colors and Editing", 0, 0,XDU(98),YDU(92), Style&, ExStyle& To hListFrame&
    Control Add ScrollBar, hListFrame&,%HorzScrollbar,"" ,XDU(20.0),YDU(66.0),XDU(70.62),YDU(3.7), _
        %WS_CHILD Or %WS_VISIBLE Or %SBS_HORZ
    Control Add Button, hListFrame&,  %ExitButton,  "E&xit",XDU(80),YDU(75),XDU(10),YDU(4.43), _
        %WS_CHILD Or %WS_VISIBLE Or %BS_PUSHBUTTON Or %WS_TABSTOP Call CBF_Exit
    Control Add Label, hListFrame&, %EditDescript,"Double-click to edit cell", XDU(35),YDU(75),XDU(35),YDU(4.43), _
        %WS_CHILD Or %WS_VISIBLE Or %SS_CENTER
    Dialog Show Modal hListFrame& Call ListFrameCallBack
    ' Handle of original frame window is: hListFrame&
End Function
' --------------------------------------------------
CallBack Function ListFrameCallBack
    'CBHNDL = hListFrame&
    Local i&,j&
    Select Case CbMsg
        Case %WM_INITDIALOG
            ' Specification of size of array.
            ' You may test other sizes.
            Rows=100
            Columns=500
            '
            ' Grid routines are made for arrays no less than (4,20)
            Columns=Max(4,Columns)
            Rows=Max(20,Rows)
            ' Two empty columns are being added.
            ReDim DataArray(0:Columns+2,0:Rows+2)' Column zero and row zero are used for headers.
            ReDim ColWidth(0:Columns+2) ' Each column may have it own width if you want that at some time.
            ' Fill array with data
            For i&=0 To Columns
                For j&=0 To Rows
                    If i&=0 Then      ' Column zero is used for row headers.
                        If j&=0 Then  ' Label of row header column.
                            DataArray(i&,j&)= " row"
                        Else     '    ' Text of row headers.
                            DataArray(i&,j&)= " row"+Str$(j&)
                        End If
                    Else     ' i& >= 1
                        If j&=0 Then  ' Row zero is used for column headers.
                            DataArray(i&,j&)= " column"+Str$(i&)
                        Else ' j& >= 1  Item/subitem content
                            DataArray(i&,j&)= " column"+Str$(i&)+" row"+Str$(j&)
                        End If
                    End If
                Next
            Next
            '
            ' Number of rows and columns in a displayed page
            PageRows=20
            PageColumns = 4
            '
            ' The scrollbar control bits are based on a fine example
            ' by Lance Edmonds in the source code forum.
            '
            ' Define external horizontal scrollbar.
            ' The build-in horizontal scrollbar of listview is not used.
            siX.cbSize = SizeOf(siX)
            siX.fMask  = %SIF_ALL   ' = %SIF_RANGE OR %SIF_PAGE OR %SIF_POS
            siX.nMin   = 1
            siX.nMax   = Columns + 2 ' Two extra empty columns
            siX.nPage  = PageColumns
            siX.nPos   = 1
            Control Send CbHndl, %HorzScrollbar, %SBM_SETSCROLLINFO, %FALSE, VarPtr(siX)
            '
            ' The build-in vertical scrollbar of listview is being used.
            '
            ' Make "viewport" for the listview to be created
            Dialog New CbHndl, "", XDU(1.8),YDU(2.9),XDU(91.1),YDU(63.5), %WS_CHILD Or %WS_VISIBLE, To hListWindow&
            ' Make this dialog modeless
            Dialog Show Modeless hListWindow& Call ListViewWindowCallBack
            '
            ' Define columns in listview
            Call DefineColumns(siX.nPos)
            '
            Call SpecifyDataColorsAndFonts
            '
            ' Get handle for the listview header the simple direct way.
            hHeader& = ListView_GetHeader (hListForm&)
            ' Set column header font
            SendMessage hHeader&,%WM_SETFONT,TextFont(-1),MakLng(%TRUE,0)
            '
            SetFocus hListWindow&
            '
            Function=1: Exit Function
        Case %WM_HSCROLL
            Select Case LoWrd(CbWParam)
                Case %SB_LINERIGHT     : Incr siX.nPos
                Case %SB_PAGERIGHT     : siX.nPos = siX.nPos + siX.nPage - 1
                Case %SB_LINELEFT      : Decr siX.nPos
                Case %SB_PAGELEFT      : siX.nPos = siX.nPos - siX.nPage + 1
                Case %SB_THUMBPOSITION ,%SB_THUMBTRACK
                    ' This code allows for tracking above the 16-bit limit (65536) of HIWRD
                    ' Proposed by Borje Hagsten
                    siX.cbSize = SizeOf(siX)
                    siX.fMask  = %SIF_TRACKPOS
                    Control Send CbHndl , %HorzScrollbar, %SBM_GETSCROLLINFO,0, VarPtr(siX)
                    siX.nPos   = siX.nTrackPos
                Case Else              : Exit Function
            End Select
            ' Ensure that position is within range
            siX.nPos = Max&(siX.nMin, Min&(siX.nPos, siX.nMax - siX.nPage + 1))
            Call UpdateColumnsAndHorzScrollbar(siX.nPos)
            Function=1: Exit Function
    End Select
End Function
' --------------------------------------------------
CallBack Function ListViewWindowCallBack
    ' Callback Handle CBHNDL is: hListWindow&
    Local rc As RECT
    Local szString As Asciiz * 256
    Local i&,KK&,Result&,JJ&
    Local HeadNotif As HD_NOTIFY Ptr
    Local my_LpLvNm As NM_LISTVIEW Ptr
    Local pnmh As NMHDR Ptr
    Local lpLVDispInfo As LV_DISPINFO Ptr
    Local lplvcd As NMLVCUSTOMDRAW Ptr
    Local LVRow As Long, LVCol As Long
    Static TimeFlagC As Single
    Local TimeC As Single
    Select Case CbMsg
        Case %WM_INITDIALOG
            '
            GetClientRect CbHndl, rc
            '
            ' Dimension ColWidths such that the sum of any displayed sets
            ' of columns (including the row header column) is one pixel
            ' larger than the horizontal dimension of the Listview display
            ' minus the vertical scroll bar. This has the effect of having
            ' a hidden internal horizontal listview scroll bar made. This
            ' ensures that the bottom line will not go below the lower edge
            ' of the listview viewport.
            KK&=rc.nRight-rc.nLeft-GetSystemMetrics(%SM_CYVSCROLL)
            JJ&=KK& \(PageColumns+1)
            KK&=KK&-PageColumns*JJ&+1
            For i&=0 To Columns + 2 ' two extra columns can be displayed.
                If i&=0 Then ColWidth(i&)= KK& Else ColWidth(i&)=JJ&
            Next
            '
            ' ******* This code is due to Semen Matusovski **************
            '
            ' Make Listview control with internal horizontal scroll bar outside the
            ' the edge of the created viewport. This has the effect of
            ' effectively hiding the internal horizontal scroll bar.
            hListForm& = CreateWindowEx(0, "SysListView32", ByVal 0, _
               %WS_CHILD Or %WS_VISIBLE Or %LVS_REPORT Or %LVS_AUTOARRANGE Or %LVS_OWNERDATA, 0, 0, _
               rc.nRight, rc.nBottom + GetSystemMetrics(%SM_CYHSCROLL), _
               CbHndl, %ListViewGrid, GetModuleHandle(""), ByVal 0)
               ' The %LVS_OWNERDATA style means that ListView will request
               ' items when needed through %LVN_GETDISPINFO message.
            '
            i = SendMessage (hListForm&, %ListViewGrid, %LVM_GETEXTENDEDLISTVIEWSTYLE, 0)
            i = i Or %LVS_EX_GRIDLINES Or %LVS_EX_FULLROWSELECT
            SendMessage hListForm&, %LVM_SETEXTENDEDLISTVIEWSTYLE, 0, i
            '
            GetClientRect hListForm&, rc
            ' ***********************************************************
            '
            ' Subclass %ListViewGrid
            gOldSubClassProc = SetWindowLong(hListForm&,%GWL_WNDPROC, CodePtr(SubClassKeys))
            '
        Case %WM_NOTIFY
            If LoWrd(CbWParam)= %ListViewGrid Then
                    ' This double click section has been inspired by the
                    ' code by David L Morris.
                    my_LpLvNm = CbLParam
                    Select Case @my_LpLvNm.hdr.code
                        Case %NM_DBLCLK
                        'CASE %NM_CLICK ' You can use single click instead if you wnat
                            'cursor position
                            LVRow = @my_LpLvNm.iItem
                            LVCol = @my_LpLvNm.iSubItem
                            ' Get array indices corresponding to selected cell
                            SelX = siX.nPos + LVCol - 1 ' adjust for presence of "internal" row header
                            SelY = LVRow + 1
                            If LVCol>0 And SelX<=Columns Then EditFlag=1 : Call EditCellForm(hListForm&) ' Edit cell - new text to data array
                            EditFlag&=EditFlag&+2
                            SetFocus hListForm&
                            InvalidateRect hListForm&,ByVal %NULL,%FALSE
                            If EditFlag&=4 Then MsgBox "You reached the last column.",%MB_ICONSTOP,"Editing stopped."
                            If EditFlag&=5 Then MsgBox "You reached the last row.",%MB_ICONSTOP,"Editing stopped."
                            EditFlag=0
                            Function = 1
                            Exit Function
                        Case %NM_CUSTOMDRAW
                            ' This section is inspired by feedback from
                            ' Semen Matusovski, David Kenny and Lance Edmonds
                            lplvcd = CbLParam
                            If(@lplvcd.nmcd.dwDrawStage = %CDDS_PREPAINT) Then
                                ' The following statement ensures that the relevant
                                ' messages are coming back to Windows, so Windows
                                ' can respond appropriately. This method may be useful
                                ' in many other situations where the DDT engine may
                                ' swallow the information.
                                ' The following statement makes Windows happy:
                                SetWindowLong hListWindow&,%DWL_MSGRESULT,%CDRF_NOTIFYITEMDRAW
                                ' This statement makes the DDT engine happy:
                                Function = 1: Exit Function
                            End If
                            If(@lplvcd.nmcd.dwDrawStage = %CDDS_ITEMPREPAINT) Then
                                SetWindowLong hListWindow&,%DWL_MSGRESULT,%CDRF_NOTIFYSUBITEMDRAW
                                Function = 1: Exit Function
                            End If
                            If(@lplvcd.nmcd.dwDrawStage = %CDDS_SUBITEM Or %CDDS_ITEMPREPAINT)  Then
                                If @lplvcd.iSubItem = 0 Then             ' Row header
                                    ' Specify background color
                                    @lplvcd.clrTextBk = RGB(227,227,227) ' light gray
                                    ' Specify text color
                                    @lplvcd.clrText = RGB(0,0,0)         ' black
                                    ' Specify font
                                    SelectObject @lplvcd.nmcd.hdc, TextFont(-1)
                                Else                                     ' Column 1 and beyond
                                    KK& = @lplvcd.nmcd.dwItemSpec + @lplvcd.iSubItem + siX.nPos
                                    If EditFlag&<>1 Then ' No cell is being edited.
                                         ' Specify background color
                                        @lplvcd.clrTextBk = RainBowColors(KK& Mod 72)
                                         ' Specify text color
                                        @lplvcd.clrText = TextColor(KK& Mod 72)
                                    Else ' A cell is being edited.
                                         ' Is the currently drawn cell that being edited?
                                        If (@lplvcd.nmcd.dwItemSpec + 1 = SelY) And (@lplvcd.iSubItem + siX.nPos - 1 = SelX) Then
                                             ' Yes. Then make it gray with white text.
                                            @lplvcd.clrTextBk = RGB(120,120,120)
                                            @lplvcd.clrText = RGB(255,255,255)
                                        Else ' No. Then give it the usual colors.
                                            @lplvcd.clrTextBk = RainBowColors(KK& Mod 72)
                                            @lplvcd.clrText = TextColor(KK& Mod 72)
                                        End If
                                    End If
                                    ' Specify font
                                    SelectObject @lplvcd.nmcd.hdc, TextFont(KK& Mod 29)
                                End If
                                SetWindowLong hListWindow&,%DWL_MSGRESULT,(%CDRF_NEWFONT)' OR %CDRF_NOTIFYSUBITEMDRAW)
                                Function = 1: Exit Function
                            End If
                        Case %LVN_GETDISPINFO    'Virtual ListView ask for Item text
                            lpLVDispInfo = CbLParam
                            If (@lpLVDispInfo.item.mask And %LVIF_TEXT) Then
                                ' Specify text to be used
                                If @lpLVDispInfo.item.iSubItem = 0 Then ' row header
                                    szString = DataArray(0 , @lpLVDispInfo.item.iItem + 1)
                                Else                                    ' column 1 and beyond
                                    szString = DataArray(@lpLVDispInfo.item.iSubItem + siX.nPos - 1 , @lpLVDispInfo.item.iItem + 1)
                                End If
                                @lpLVDispInfo.item.pszText = VarPtr(szString)
                                Function = 1: Exit Function
                            End If
                        Case Else
                    End Select
            End If
            '
            HeadNotif = CbLParam
            If @HeadNotif.hdr.hwndFrom = hHeader& Then
                If @HeadNotif.hdr.code = %HDN_ITEMCHANGED Then
                    ' Prevent column width to be less than the original setting.
                    ' This arrangement means the following few lines are
                    ' executed only at 0.6 seconds interval at the most.
                    TimeC=Timer
                    If TimeC-TimeFlagC > 0.6 Then
                        Result&=SendMessage(hListForm&,%LVM_GETCOLUMNWIDTH, 0, 0)
                        If Result&<ColWidth(0) Then
                            SendMessage hListForm&,%LVM_SETCOLUMNWIDTH, 0, MakLng(ColWidth(0), 0) ' Row header
                            InvalidateRect hListForm&,ByVal %NULL,%FALSE
                        Else
                            For KK& = siX.nPos To siX.nPos+PageColumns-1
                                Result&=SendMessage(hListForm&,%LVM_GETCOLUMNWIDTH,KK&-siX.nPos+1, 0)
                                If Result&<ColWidth(KK&) Then
                                    SendMessage hListForm&,%LVM_SETCOLUMNWIDTH,KK&-siX.nPos+1, MakLng(ColWidth(KK&), 0)
                                    InvalidateRect hListForm&,ByVal %NULL,%FALSE
                                End If
                            Next
                        End If
                        TimeFlagC = Timer
                    End If
                End If
            End If
        Case %WM_DESTROY
            For i=-1 To 28  ' Delete fonts that have been made.
                Call DeleteObject (TextFont(i&))
            Next
            ' Important! Remove the subclassing
            SetWindowLong hListForm&, %GWL_WNDPROC, gOldSubClassProc
            ' -----------------------------------------------
        Case Else
    End Select
End Function
' -----------------------------------------------
CallBack Function SubClassKeys
    ' Subclass callback function for processing key messages.
    ' Inspired by Lance Edmonds who provided a fine example in the Source Code Forum
    Local Result&
    Select Case CbMsg
        Case %WM_KEYDOWN ' Keys at time of pressing
            Select Case CbWParam
                Case %VK_LEFT  : Decr siX.nPos
                Case %VK_RIGHT : Incr siX.nPos
                Case %VK_HOME  : siX.nPos = 0
                Case %VK_END   : siX.nPos = Columns+2
                Case Else : Exit Select
            End Select
            ' Ensure that positions are within range
            siX.nPos = Max&(siX.nMin, Min&(siX.nPos, siX.nMax - siX.nPage + 1))
            Call UpdateColumnsAndHorzScrollbar(siX.nPos)
        Case %WM_KEYUP ' Keys at time of release (not used)
        Case %WM_CHAR  ' Any character key at time of pressing (not used)
    End Select
    ' Pass the message on to the original window procedure... the DDT engine!
    Function = CallWindowProc(gOldSubClassProc, CbHndl, CbMsg, CbWParam, CbLParam)
End Function
' --------------------------------------------------
Sub SetColumnText(ByVal ColPos As Long,ByVal ArrayPos As Long,ByVal txt As String)
    Local zText As Asciiz * 100
    Local lvc As LV_COLUMN
    lvc.mask = %LVCF_TEXT Or %LVCF_WIDTH 'OR %LVCF_SUBITEM OR %LVCF_FMT
    ' Get relevant data about column structure
    SendMessage hListForm&, %LVM_GETCOLUMN, ColPos, VarPtr(lvc)
    lvc.cx = ColWidth(ArrayPos) ' make sure to maintain original column width
    zText = txt
    lvc.pszText = VarPtr(zText)
    ' Send new text to column
    SendMessage hListForm&,%LVM_SETCOLUMN, ColPos, VarPtr(lvc)
End Sub
' ------------------------------------------------
Sub DefineColumns(ByVal xPos As Long)
    Local lvc As LV_COLUMN
    Local zText As Asciiz * 100
    Local KK&
    lvc.mask = %LVCF_FMT Or %LVCF_WIDTH Or %LVCF_TEXT Or %LVCF_SUBITEM
    lvc.cchTextMax = 100
    ' Make column headers
    For KK& = xPos To xPos+PageColumns ' includes row header column
        lvc.cx = ColWidth(KK&-1)
        ' column header text
        lvc.fmt = %LVCFMT_LEFT ' set justification
        zText = DataArray(KK&-1,0)
        LVC.pszText = VarPtr(zText)
        SendMessage hListForm&,%LVM_INSERTCOLUMN, KK&, VarPtr(lvc)
    Next
    '
    ' Dimension the listview in regard to total number of rows.
    ' This includes dimensioning of the internal vertical scroll bar
    ' of listview which we use. Thus no external vertical
    ' scroll bar is necessary in this program.
    ListView_SetItemCountEx hListForm&,Rows,%LVSICF_NOINVALIDATEALL
End Sub
' ------------------------------------------------
Sub UpdateColumnsAndHorzScrollbar(ByVal xPos As Long)
    Local KK&
    Static xPrevPos As Long  ' previous x-position (remember between calls)
    SetFocus hListForm&
    '
    If xPos<>xPrevPos Then ' Moved in X-direction (horizontal)
        ' Update horizontal scroll bar
        siX.fMask = %SIF_POS
        Control Send hListFrame& , %HorzScrollbar, %SBM_SETSCROLLINFO, %TRUE, VarPtr(siX)
        ' Set row header coloumn width to ensure it is kept constant
        SendMessage hListForm&,%LVM_SETCOLUMNWIDTH, 0, MakLng(ColWidth(0), 0)
        ' Update column headers
        For KK& = xPos To xPos+PageColumns-1
            Call SetColumnText(KK&-xPos+1,KK&,DataArray(KK&,0))
        Next
        ' Force updating of listview to be made
        InvalidateRect hListForm&,ByVal %NULL,%FALSE
    End If
    xPrevPos=xPos ' Remember new previous x-position
End Sub
' ------------------------------------------------
CallBack Function CBF_Exit
    Local res&
    res&=MsgBox ("Are you sure?",%MB_YESNO Or %MB_ICONQUESTION ,"Exit Program?")
    If res&=%IDYES Then Dialog End hListFrame&
End Function
' --------------------------------------------------------------
Sub SpecifyDataColorsAndFonts
    Local i&,j&, Red&, Green&, Blue&,KK&,II&,k&,l&,m&,JJ&
    ReDim RainBowColors(0:71)
    ReDim TextColor(0:71)
    ReDim TextFont (-1:28)
    For i&=0 To 359 Step 5          ' one 360 degrees turn (color loop)
        Call GetRainbowRGB(ByRef i&,ByRef Red&,ByRef Green&,ByRef Blue&)
        RainBowColors(i/5)=RGB(Red&,Green&,Blue&)
        ' Decide from color if text should be black or white
        ' This function is suited when transformation to a grey scale is needed.
        If Red&*.222+Green&*.707+Blue&*.071>128 Then  ' Color is light,
            TextColor(i/5)=RGB(0,0,0)                 ' then text should be black.
        Else                                          ' Color is dark,
            TextColor(i/5)=RGB(255,255,255)           ' then text should be white.
        End If
    Next
    i&=-1   : TextFont(i)=MakeFont(9,700,0,0,0,"Klang MT")
    Incr i& : TextFont(i)=MakeFont(8,700,0,0,0,"Papyrus")
    Incr i& : TextFont(i)=MakeFont(8,600,0,0,0,"Tempus Sans ITC")
    Incr i& : TextFont(i)=MakeFont(9,400,0,0,0,"Klang MT")
    Incr i& : TextFont(i)=MakeFont(9,400,0,0,0,"Eras Medium ITC")
    Incr i& : TextFont(i)=MakeFont(11,400,0,0,0,"Edwardian Script ITC")
    For k&=400 To 700 Step 300  ' Font Weight loop - normal or bold
        For l&=0 To 1           ' Italic loop - normal or italic
            For m&=0 To 1       ' Underline loop - normal or underline
                Incr i& : TextFont(i)=MakeFont(8,k&,l&,m&,0,"Arial")
                Incr i& : TextFont(i)=MakeFont(7,k&,l&,m&,0,"Courier New")
                Incr i& : TextFont(i)=MakeFont(8,k&,l&,m&,0,"Times New Roman")
            Next
        Next
    Next
End Sub
' ------------------------------------------------
Sub GetRainbowRGB(ByRef i&,ByRef Red&,ByRef Green&,ByRef Blue&)
    Select Case i& 'i& can vary between 0 and 359 (full circle)
        Case 0 To 59
            Red&=(i& Mod 60)*4.25       ' increasing red
            Green&=255                  ' maximum green
            Blue&=0                     ' no blue
        Case 60 To 119
            Red&=255                    ' maximum red
            Green&=255-(i& Mod 60)*4.25 ' decreasing green
            Blue&=0                     ' no blue
        Case 120 To 179
            Red&=255                    ' maximum red
            Green&=0                    ' no green
            Blue&=(i& Mod 60)*4.25      ' increasing blue
        Case 180 To 239
            Red&=255-(i& Mod 60)*4.25   ' decreasing red
            Green&=0                    ' no green
            Blue&= 255                  ' maximum blue
        Case 240 To 299
            Red&=0                      ' no red
            Green&=(i& Mod 60)*4.25     ' increasing green
            Blue& = 255                 ' maximum blue
        Case 300 To 359
            Red&=0                      ' no red
            Green&=255                  ' maximum green
            Blue&=255-(i& Mod 60)*4.25  ' decreasing blue
        Case Else
    End Select
End Sub
' ------------------------------------------------
Function MakeFont(ByVal FontTypeSize As Long,ByVal FontWeight As Long, _
    ByVal Italic As Long, ByVal Underline As Long,ByVal StrikeOut As Long, _
    ByVal FaceName As String) As Long
    Local lfFont As LOGFONT, hDC As Long,LogPixelsY As Long
' -----------------------
    'TYPE LOGFONT defines the attributes of a font.
    'See LOGFONT in the Win32 help file
    hDC = GetDC(%HWND_DESKTOP)
    '
    'Retrieves device-specific information about the number
    'of pixels per logical inch along the screen height
    '(depends on screen resolution setting).
    'This is important to define appropriate font sizes.
    LogPixelsY  = GetDeviceCaps(hDC, %LOGPIXELSY)
    '
    ReleaseDC %HWND_DESKTOP, hDC
    '
    lfFont.lfHeight = -MulDiv(FontTypeSize,LogPixelsY,72) '-(FontTypeSize * LogPixelsY) \ 72
                                            ' logical height of font
    lfFont.lfWidth = 0                      ' logical average character width
    lfFont.lfEscapement = 0                 ' angle of escapement
    lfFont.lfOrientation = 0                ' base-line orientation angle
    lfFont.lfWeight = FontWeight            ' font weight
    lfFont.lfItalic = Italic                ' italic attribute flag (0,1)
    lfFont.lfUnderline = Underline          ' underline attribute flag (0,1)
    lfFont.lfStrikeOut = StrikeOut          ' strikeout attribute flag (0,1)
    lfFont.lfCharSet = %ANSI_CHARSET        ' character set identifier
    lfFont.lfOutPrecision = %OUT_TT_PRECIS  ' output precision
    lfFont.lfClipPrecision = %CLIP_DEFAULT_PRECIS  ' clipping precision
    lfFont.lfQuality = %DEFAULT_QUALITY     ' output quality
    lfFont.lfPitchAndFamily = %FF_DONTCARE  ' pitch and family
    lfFont.lfFaceName = FaceName            ' typeface name string
' -----------------------
    ' Make font according to specifications
    Function = CreateFontIndirect (lfFont)
End Function
'
' ------------------------------------------------
' Code section for editing of cell text
' ------------------------------------------------
'
Sub EditCellForm(ByVal hListForm&) ' make and display edit form
    Local Style&, ExStyle&
    Style& = %WS_POPUP Or %DS_MODALFRAME Or %WS_CAPTION 'OR %DS_CENTER
    ExStyle& = 0
    Dialog New hListForm&, "Edit cell", 0, YMaxScr/YCR!-78,  200,  78, Style&, ExStyle& To hEditForm&
    Control Add Label, hEditForm&,  %EditLabel,  "Column"+Str$(SelX)+"  Row"+Str$(SelY), 6, 2, 188, 10, _
        %WS_CHILD Or %WS_VISIBLE Or %SS_CENTER
    Control Add TextBox, hEditForm&,  %EditText,  DataArray(SelX,SelY), 6, 12, 188, 12, _
        %WS_CHILD Or %WS_VISIBLE Or %ES_AUTOHSCROLL Or %WS_TABSTOP, %WS_EX_CLIENTEDGE
    Control Send hEditForm&, %EditText,%EM_SETSEL,0,-1  ' select all text
    Control Add Button, hEditForm&,  %EditOK,  "&OK", 154, 60, 40, 12, _
        %WS_CHILD Or %WS_VISIBLE Or %BS_PUSHBUTTON Or %WS_TABSTOP Call CBF_EditOK
    Control Add Button, hEditForm&,  %EditCancel,  "&Cancel", 104, 60, 40, 12, _
        %WS_CHILD Or %WS_VISIBLE Or %BS_PUSHBUTTON Or %WS_TABSTOP Call CBF_EditCancel
    Control Add Label, hEditForm&,  %LabelRadioButtonAction,  "Action After Pressing ENTER or Clicking OK:", 8, 28, 160, 10
    Control Add Option, hEditForm&,  %RadioButtonFinishEditing,  "Finish Editing", 15, 40, 58, 10, _
        %WS_CHILD Or %WS_VISIBLE Or %BS_AUTORADIOBUTTON Or %WS_GROUP Or %WS_TABSTOP Call CBF_RadioButtonFinishEdit
    Control Add Option, hEditForm&,  %RadioButtonEditRight,  "Edit Cell to the Right", 15, 52, 86, 10 Call CBF_RadioButtonEditRight
    Control Add Option, hEditForm&,  %RadioButtonEditBelow,  "Edit Cell Below", 15, 64, 62, 10 Call CBF_RadioButtonEditBelow
    Control Send hEditForm&,%RadioButtonFinishEditing,%BM_SETCHECK,%BST_CHECKED,0
    Dialog Show Modal hEditForm&, Call EditDialogProc
End Sub
' ------------------------------------------------
CallBack Function EditDialogProc
    Local hCtl&,j&,Result&
    Select Case CbMsg
        Case %WM_INITDIALOG
            Control Handle CbHndl, %EditText To hCtl&
            gOldSubClassEdit& = SetWindowLong(hCtl&, %GWL_WNDPROC, CodePtr(SubClassEditKeys))
        Case %WM_DESTROY
            ' Important! Remove the subclassing
            SetWindowLong hCtl&, %GWL_WNDPROC, gOldSubClassEdit&
        Case Else
    End Select
End Function
' ------------------------------------------------
CallBack Function SubClassEditKeys
    ' Subclass callback function for processing key messages in edit control (textbox).
    ' Completed after valuable feedback by Semen Matusovski and Borje Hagsten.
    Local Result&
    '
    Select Case CbMsg
        '
        ' The %WM_GETDLGCODE message is sent to the dialog box procedure
        ' associated with a control. Normally, Windows handles all arrow-key
        ' and TAB-key input to the control.
        ' By responding to the %WM_GETDLGCODE message, an application can
        ' take control of a particular type of input and process the input itself.
        Case %WM_GETDLGCODE
            ' Specifies that we want all keys entered in the textbox to be
            ' available here.
            Function = %DLGC_WANTALLKEYS: Exit Function
        Case %WM_KEYDOWN ' Keys at time of pressing (not used here)
        Case %WM_KEYUP   ' Keys at time of release (not used here)
        Case %WM_CHAR    ' Any character key at time of pressing
            Select Case CbWParam ' Holds the code of the key.
                ' Specify what action should be taken for each key code.
                Case %VK_RETURN ' 13 ' ENTER pressed
                    Call EditingOptionsOnENTERorOK
                    Exit Function
                Case %VK_ESCAPE ' 27 ' ESCAPE pressed
                    Dialog End hEditForm&
                    Exit Function
                Case Else ' No action to be taken here for the other keys.
            End Select
    End Select
    ' Pass the message on to the original window procedure... the DDT engine!
    Function = CallWindowProc(gOldSubClassEdit&, CbHndl, CbMsg, CbWParam, CbLParam)
End Function
' ------------------------------------------------
CallBack Function CBF_EditOK
    Call EditingOptionsOnENTERorOK
End Function
' ------------------------------------------------
Sub EditingOptionsOnENTERorOK
    Local result&,Tin&,res2&
    Local Dif As Long, RenewFlag&
    Dim pt As POINTAPI
    '
    Control Send hEditForm&,%RadioButtonFinishEditing,%BM_GETCHECK,0,0 To result&
    If result&=%BST_CHECKED Then ' Finish editing.
        ' update data array with edited text
        Control Get Text hEditForm&,%EditText To DataArray(SelX,SelY)
        Dialog End hEditForm&
    End If
    '
    Control Send hEditForm&,%RadioButtonEditRight,%BM_GETCHECK,0,0 To result&
    If result&=%BST_CHECKED Then ' Edit cell to the right.
        ' update data array with previously edited text
        Control Get Text hEditForm&,%EditText To DataArray(SelX,SelY)
        '
        If SelX>=Columns Then ' last cell in row - finish editing
            Beep : EditFlag&=2 : Dialog End hEditForm&
        Else
            ' Move to the right
            Incr SelX : If SelX > siX.nPos + PageColumns -1 Then Incr siX.nPos
            siX.nPos = Max&(siX.nMin, Min&(siX.nPos, siX.nMax - siX.nPage + 1))
        End If
        Control Set Text hEditForm&,%EditLabel,"Column"+Str$(SelX)+"  Row"+Str$(SelY)
        Control Set Text hEditForm&,%EditText, DataArray(SelX,SelY)
        Control Send hEditForm&, %EditText,%EM_SETSEL,0,-1  ' select all text
        Control Set Focus hEditForm&,%EditText
    End If
    '
    Control Send hEditForm&,%RadioButtonEditBelow,%BM_GETCHECK,0,0 To result&
    If result&=%BST_CHECKED Then ' Edit cell below.
        ' update data array with previously edited text
        Control Get Text hEditForm&,%EditText To DataArray(SelX,SelY)
        If SelY>=Rows Then ' last cell in column - finish editing
            Beep : EditFlag&=3 : Dialog End hEditForm&
        Else
            ' Move down
            Incr SelY
            Tin&=ListView_GetTopIndex(hListForm&)
            res2& = SendMessage(hListForm&, %LVM_GETITEMPOSITION,Tin&, VarPtr(pt))
            Dif = pt.y
            res2& = SendMessage(hListForm&, %LVM_GETITEMPOSITION,Tin&+1, VarPtr(pt))
            Dif = pt.y - Dif ' Vertical pixels of one line of listview.
            If SelY-Tin&>PageRows Then ' Scroll listview one line down.
                Tin&=ListView_Scroll(hListForm&,0,Dif)
            End If
        End If
        Control Set Text hEditForm&,%EditLabel,"Column"+Str$(SelX)+"  Row"+Str$(SelY)
        Control Set Text hEditForm&,%EditText, DataArray(SelX,SelY)
        Control Send hEditForm&, %EditText,%EM_SETSEL,0,-1  ' select all text
        Control Set Focus hEditForm&,%EditText
    End If
    Call UpdateColumnsAndHorzScrollbar(siX.nPos)
    ' Force updating of listview to be made
    InvalidateRect hListForm&,ByVal %NULL,%FALSE
End Sub
' ------------------------------------------------
CallBack Function CBF_EditCancel
    Dialog End hEditForm&
End Function
' ------------------------------------------------
CallBack Function CBF_RadioButtonFinishEdit
    Control Set Focus hEditForm&,%EditText
End Function
' ------------------------------------------------
CallBack Function CBF_RadioButtonEditRight
    Control Set Focus hEditForm&,%EditText
End Function
' ------------------------------------------------
CallBack Function CBF_RadioButtonEditBelow
    Control Set Focus hEditForm&,%EditText
End Function
' ------------------------------------------------
